%{!?lua_version: %global lua_version %{lua: print(string.sub(_VERSION, 5))}}
%{!?lua_libdir: %global lua_libdir %{_libdir}/lua/%{lua_version}}
%{!?lua_pkgdir: %global lua_pkgdir %{_datadir}/lua/%{lua_version}}

%global enable_docs 1

%global enable_docs 0

Summary:        Bindings of libevent to Lua
Name:           lua-event
Version:        0.4.6
Release:    2%{?dist}
License:        MIT
URL:            https://github.com/harningt/luaevent/
Source0:        https://github.com/harningt/luaevent/archive/v%{version}/luaevent-%{version}.tar.gz

Patch0:         %{name}-0.4.3-respect-cflags.patch
Patch1:         luaevent-0.4.3-envfix.patch

Requires:       lua(abi) = %{lua_version}
Requires:       lua-socket
BuildRequires:  gcc
BuildRequires:  make
BuildRequires:  lua >= %{lua_version}
BuildRequires:  lua-devel >= %{lua_version}
BuildRequires:  libevent-devel >= 1.4

%description
Lua bindings for libevent, an asynchronous event notification library
that provides a mechanism to execute a callback function when a specific
event occurs on a file descriptor or after a timeout has been reached.

%if 0%{?enable_docs}
%package doc
Summary:        Documentation for %{name}
BuildArch:      noarch
BuildRequires:  ikiwiki

%description doc
This package contains documentation for developing applications that
use Lua bindings for libevent, an asynchronous event notification library
that provides a mechanism to execute a callback function when a specific
event occurs on a file descriptor or after a timeout has been reached.
%endif

%prep
%setup -q -n luaevent-%{version}
%patch0 -p1
%patch1 -p1 -b .envfix
rm -f doc/modules/luaevent.mdwn

%build
export CFLAGS="$RPM_OPT_FLAGS -fPIC"
export LDFLAGS="$RPM_LD_FLAGS -shared"
%make_build

%if 0%{?enable_docs}
/bin/sh makeDocs.sh
%endif

%install
%make_install \
  INSTALL_DIR_LUA=%{lua_pkgdir} \
  INSTALL_DIR_BIN=%{lua_libdir}

%check
lua -e \
  'package.cpath="%{buildroot}%{lua_libdir}/?.so;"..package.cpath;
   package.path="%{buildroot}%{lua_pkgdir}/?.lua;"..package.path;
   dofile("test/basic.lua");'

%files
%license doc/COPYING
%doc CHANGELOG README doc/COROUTINE_MANAGEMENT doc/PLAN
%dir %{lua_libdir}/luaevent/
%{lua_libdir}/luaevent/core.so
%{lua_pkgdir}/luaevent.lua

%if 0%{?enable_docs}
%files doc
%doc html/*
%endif

%changelog
* Wed Jun 11 2025 bbrucezhang <bbrucezhang@tencent.com> - 0.4.6-2
- Rebuilt for loongarch64

* Thu Aug 22 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.4.6-1
- initial build
